﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DataAccessLayer
{
    public class GenericDataProvider<T>
    {

        NHibernate.ISession _session;


        /// <summary>
        /// Initializes a new instance of the GenericProvider class.
        /// </summary>
        /// <param name="session"></param>
        public GenericDataProvider(NHibernate.ISession session)
        {
            _session = session;
        }

        public T GetById(object id)
        {
            return _session.Get<T>(id);
        }


        public IList<T> Find(NHibernate.Expression.DetachedCriteria dc)
        {
            return dc.GetExecutableCriteria(_session).List<T>();
        }

        //public T FindOne(NHibernate.Expression.DetachedCriteria dc)
        //{
        //    return dc.GetExecutableCriteria(_session).UniqueResult<T>;
        //}

    }
}
